# ===============================================================================
# EXAMPLE
# 1. Find user "DEMO"
# 2. Find first project assigned to the user
# 3. Add a timestamp for user to the project
# ===============================================================================

from xtrestapi_wrapper import *

# Login params to XTCloudserver
API_URL = "http://localhost:9000/api/"
API_KEY = "6D12E349-331A-4BBF-B630-A275A56308BC"
API_USERNAME = "demo"
API_PASSWORD = "demo"

USERNAME = "demo"
PASSWORD = "demo"

if __name__ == "__main__":
     # Initialize class with APIKEY
     xtrestapi = XTRESTAPI(API_URL, API_KEY, API_USERNAME, API_PASSWORD)

     # Check if the API-Level matches the webservers API-Level
     xtrestapi.CheckApiLevelOk(True)

     # Login with user "demo"
     print(f"\nLogin({USERNAME}, {PASSWORD})")
     response = xtrestapi.Login(USERNAME, PASSWORD)
     print(f"{response.status_code}: {response.reason}")
     if response.status_code == 200:
          # Get user "DEMO"
          print(f"\nGetUserByLoginname()")
          result = xtrestapi.check(xtrestapi.GetUserByLoginname("DEMO"), True)
          if result != None:
               user_nr = result
               if user_nr != '':
                    # Get list of user projects
                    params = {
                    "user_nr": user_nr,
                    "assignedtouser": "true"
                    }
                    print(f"\nGetProjects({params})")
                    result = xtrestapi.check(xtrestapi.GetProjects(params), True)
                    if result != None:
                         # Pick first project from list
                         project_nr = result[0]["project_nr"]
                         print(f"=> First project in list is: {project_nr}")
                         # Add timestamp for user
                         timestamp = {
                         "user_nr": user_nr,
                         "project_nr": project_nr,
                         "fromtime": "2021-03-10T10:00:00.000",
                         "tilltime": "2021-03-10T12:00:00.000",
                         "comment": "New timestamp",
                         }
                         print(f"\nCreateTimestamp({timestamp})")
                         result = xtrestapi.check(xtrestapi.CreateTimestamp(timestamp), True)
                         if result != None:
                              print(f"=> Timestamp {result} was added")
               else:
                    print(f"\n=> User not found")


     else:
          print('Login error:',response.reason)
