# ===============================================================================
# EXAMPLE: Assign user "DEMO" to the first project in the list
# ===============================================================================

from xtrestapi_wrapper import *

# Login params to XTCloudserver
API_URL = "http://localhost:9000/api/"
API_KEY = "6D12E349-331A-4BBF-B630-A275A56308BC"
API_USERNAME = "demo"
API_PASSWORD = "demo"

USERNAME = "demo"
PASSWORD = "demo"

if __name__ == "__main__":
     # Initialize class with APIKEY
     xtrestapi = XTRESTAPI(API_URL, API_KEY, API_USERNAME, API_PASSWORD)

     # Check if the API-Level matches the webservers API-Level
     xtrestapi.CheckApiLevelOk(True)

     # Login with user "demo"
     print(f"\nLogin({USERNAME}, {PASSWORD})")
     response = xtrestapi.Login(USERNAME, PASSWORD)
     print(f"{response.status_code}: {response.reason}")
     if response.status_code == 200:
          # Get user "DEMO"
          print(f"\nGetUserByLoginname()")
          result = xtrestapi.check(xtrestapi.GetUserByLoginname("DEMO"), True)
          if result != None:
               user_nr = result
               if user_nr != '':
                    # Get list of all projects
                    params = { }
                    print(f"\nGetProjects()")
                    result = xtrestapi.check(xtrestapi.GetProjects(params), True)
                    if result != None:
                         # Pick first project from list
                         project_nr = result[0]["project_nr"]
                         print(f"=> First project in list is: {project_nr}")
                         # Assign User to Project
                         print(f"\nProjectAssignUser()")
                         result = xtrestapi.check(xtrestapi.ProjectAssignUser(project_nr, user_nr), True)
                         if result != None:
                              print(f"=> Project was assigned to user")
               else:
                    print(f"=> User not found")


     else:
          print('Login error:',response.reason)

