# ===============================================================================
# EXAMPLE
# 1. Check if Client and create it otherwise
# 2. Check if Project exist and create it otherwise
# 3. Check if Task exist and create it otherwise
# 4. Change task state
# 5. Delete task
# ===============================================================================

from xtrestapi_wrapper import *

# Login params to XTCloudserver
API_URL = "http://localhost:9000/api/"
API_KEY = "6D12E349-331A-4BBF-B630-A275A56308BC"
API_USERNAME = "demo"
API_PASSWORD = "demo"

USERNAME = "demo"
PASSWORD = "demo"

if __name__ == "__main__":
     # Initialize class with APIKEY
     xtrestapi = XTRESTAPI(API_URL, API_KEY, API_USERNAME, API_PASSWORD)

     # Check if the API-Level matches the webservers API-Level
     xtrestapi.CheckApiLevelOk(True)

     # Login with user "demo"
     print(f"\nLogin({USERNAME}, {PASSWORD})")
     response = xtrestapi.Login(USERNAME, PASSWORD)
     print(f"{response.status_code}: {response.reason}")
     if response.status_code == 200:
          # Check if Client #1 exists
          print(f"\nGetClientByClientID(1)")
          result = xtrestapi.check(xtrestapi.GetClientByClientID(1), True)
          if result != None:
               # If Client does not exist, create it
               client_nr = result
               if client_nr == "":
                    # Create Client #1
                    DATA = {
                    "clientname": "Client #1",
                    "clientid": 1
                    }
                    print(f"\nCreateClient()")
                    result = xtrestapi.check(xtrestapi.CreateClient(DATA), True)
                    if result != None:
                         # Get client_nr of new client
                         client_nr = result
                    else:
                         raise Exception("Error creating client")
          else:
               raise Exception("Error")

          # Check if Project #1 exists
          print(f"\nGetProjectByProjectnumber('1')")
          result = xtrestapi.check(xtrestapi.GetProjectByProjectnumber("1"), True)
          if result != None:
               # If Project does not exist, create it
               project_nr = result
               if project_nr == "":
                    # Create Project #1
                    DATA = {
                    "projectname": "Project #1",
                    "projectnumber": "1",
                    "client_nr": client_nr
                    }
                    print(f"\nCreateProject()")
                    result = xtrestapi.check(xtrestapi.CreateProject(DATA), True)
                    if result != None:
                         # Get project_nr of new project
                         project_nr = result
                    else:
                         raise Exception("Error creating project")
          else:
               raise Exception("Error")

          # Check if Task #1 exists
          print(f"\nGetTaskByTasknumber(1)")
          result = xtrestapi.check(xtrestapi.GetTaskByTasknumber(1), True)
          if result != None:
               # If Task does not exist, create it
               todo_nr = result
               if todo_nr == "":
                    # Create Task #1
                    DATA = {
                    "subject": "Task #1",
                    "project_nr": project_nr
                    }
                    print(f"\nCreateTask()")
                    result = xtrestapi.check(xtrestapi.CreateTask(DATA), True)
                    if result != None:
                         # Get todo_nr of new task
                         todo_nr = result
                    else:
                         raise Exception("Error creating task")
          else:
               raise Exception("Error")

          # Get task object by todo_nr
          print(f"\nGetTask({todo_nr})")
          result = xtrestapi.check(xtrestapi.GetTask(todo_nr), True)
          if result != None:
               # Print out subject of task
               subject = result["subject"]
               print('=> Subject: ', subject)

               # Change Taskstate
               result['subject'] = "Task #1 Updated"
               result['taskstate'] = xtconst.tsChecking
               print(f"\nUpdateTask({todo_nr, result})")
               result = xtrestapi.check(xtrestapi.UpdateTask(todo_nr, result), True)

               # Delete task by todo_nr
               input("\nPress Enter to continue...\n")
               print(f"\nDeleteTask({todo_nr})")
               result = xtrestapi.check(xtrestapi.DeleteTask(todo_nr), True)
     else:
          print('Login error:',response.reason)

