# ===============================================================================
# EXAMPLE
# 1. Find user "DEMO"
# 2. Find first project assigned to the user
# 3. Get minutes needed of the project
# ===============================================================================

from xtrestapi_wrapper import *

# Login params to XTCloudserver
API_URL = "http://localhost:9000/api/"
API_KEY = "6D12E349-331A-4BBF-B630-A275A56308BC"
API_USERNAME = "demo"
API_PASSWORD = "demo"

USERNAME = "demo"
PASSWORD = "demo"

if __name__ == "__main__":
     # Initialize class with APIKEY
     xtrestapi = XTRESTAPI(API_URL, API_KEY, API_USERNAME, API_PASSWORD)

     # Check if the API-Level matches the webservers API-Level
     xtrestapi.CheckApiLevelOk(True)

     # Login with user "demo"
     print(f"\nLogin({USERNAME}, {PASSWORD})")
     response = xtrestapi.Login(USERNAME, PASSWORD)
     print(f"{response.status_code}: {response.reason}")
     if response.status_code == 200:
          # Get user "DEMO"
          print(f"\nGetUserByLoginname()")
          result = xtrestapi.check(xtrestapi.GetUserByLoginname("DEMO"), True)
          if result != None:
               user_nr = result
               if user_nr != '':
                    print(f"=> user_nr of 'DEMO' is {user_nr}")
                    # Get list of user projects
                    params = {
                    "user_nr": user_nr,
                    "assignedtouser": "true"
                    }
                    print(f"\nGetProjects({params})")
                    result = xtrestapi.check(xtrestapi.GetProjects(params), True)
                    if result != None:
                         # Pick first project from list
                         project_nr = result[0]["project_nr"]
                         print(f"=> First project in list is: {project_nr}")

                         # Get minutes needed for a project
                         print(f"\nProjectGetMinutesNeeded({project_nr})")
                         result = xtrestapi.check(xtrestapi.ProjectGetMinutesNeeded(project_nr), True)
                         if result != None:
                              minutesneeded = result
                              print(f"=> Minutes Needed = {minutesneeded}")

               else:
                    print(f"\n=> User not found")


     else:
          print('Login error:',response.reason)
