# ===============================================================================
# EXAMPLE
# 1. Read list of all users
# 2. Get first user from list
# 3. Print out firstname of user
# ===============================================================================
from xtrestapi_wrapper import *

# Login params to XTCloudserver
API_URL = "http://localhost:9000/api/"
API_KEY = "6D12E349-331A-4BBF-B630-A275A56308BC"
API_USERNAME = "demo"
API_PASSWORD = "demo"

USERNAME = "demo"
PASSWORD = "demo"

if __name__ == "__main__":
     # Initialize class with APIKEY
     xtrestapi = XTRESTAPI(API_URL, API_KEY, API_USERNAME, API_PASSWORD)

     # Check if the API-Level matches the webservers API-Level
     xtrestapi.CheckApiLevelOk(True)

     # Login with user "demo"
     print(f"\nLogin({USERNAME}, {PASSWORD})")
     response = xtrestapi.Login(USERNAME, PASSWORD)
     print(f"{response.status_code}: {response.reason}")
     if response.status_code == 200:
          # Get list of all users
          params = {
          "sortdirection":"asc",
          "state":1,
          "pageNumber":0,
          "pageSize":10
          }
          print(f"\nGetUsers()")
          result = xtrestapi.check(xtrestapi.GetUsers(params), True)
          if result != None:
               # Pick first user from list
               user_nr = result[0]["user_nr"]
               print(f"=> First user in list is: {user_nr}")
               # Get user object from user_nr
               print(f"\nGetUser({user_nr})")
               result = xtrestapi.check(xtrestapi.GetUser(user_nr), True)
               if result != None:
                    # Print out firstname of user
                    firstname = result['firstname']
                    print('=> Firstname: ', firstname)
     else:
          print('Login error:',response.reason)

